/* GPS Logger */
/* ukad ATmega 8MHz */

/* F_CPU w Makefile
#define F_CPU 8000000L 
#define F_CPU 11059200UL*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <util/delay.h>
#include <string.h>
#include <stdlib.h>
#include "usart.h"
#include "bargraf.h"

/*
BARGRAF:
 1   2   3   4   5
PD2 PD3 PD4 PB7 PB6
PB1 PB0 PD7 PD6 PD5
 6   7   8   9
PC2 PC3 PC4 PC5
PC0 PC1 PC2 PC3

JOYSTICK:
   PB2
PB3   PB5
   PB4
*/

char napis[256];
unsigned int pos=-1;
unsigned int czypokazywac=1;
unsigned char fix_type=0;	//1-no fix, 2-2D fix, 3-3D fix

int eeprom_pos=0;
typedef struct{
	unsigned long int time;
	double posx;
	double posy;
}gps_data;
gps_data gpsdata;

int progress=5,progress2=0;
int eeprom_data __attribute__((section(".eeprom"))) = 0;


int strcomp(char* text, char* search, int num){
	int i;
	
	for(i=0;i<num;i++)
		if(text[i]!=search[i]) return 1;
	
	return 0;
}


char* strgetpos(char* text, int pos){
	int num=0;
	
	while(*text!='\0'){
	    if(num<pos-1 && *text == ',') num++;
		else if(num==pos-1 && *text==',') { break;}
		text++;
	}

	return text;
}

int strgetint(char* text,int pos){
	int num=0;
	int wynik=0;
	//if(*text!='\0') num=text-48;
	
	while(*text!='\0'){
	    if(num<pos && *text == ',') num++;
		else if(num==pos && *text == ',') { break; }
		else if(num==pos){
			wynik=wynik*10+((*text)-'0');
		}
		text++;
	}

	return wynik;
}

unsigned long int strgetulint(char* text,int pos){
	int num=0;
	unsigned long int wynik=0;
	//if(*text!='\0') num=text-48;
	
	while(*text!='\0'){
	    if(num<pos && *text == ',') num++;
		else if(num==pos && *text == ',') { break; }
		else if(num==pos){
			wynik=wynik*10+((*text)-'0');
		}
		text++;
	}

	return wynik;
}

double strgetdouble(char* text,int pos){
	int num=0;
	double wynik=0;
	double dzielnik=1;
	//if(*text!='\0') num=text-48;
	
	while(*text!='\0'){
	    if(num<pos && *text == ',') num++;
		else if((num==pos || num==pos+1) && *text == ',') { break; }
		else if(num==pos && *text == '.') { num++; }
		else if(num==pos){
			wynik=wynik*10.0+((*text)-'0');
		}
		else if(num==pos+1){
			wynik=wynik*10.0+((*text)-'0');
			dzielnik*=10.0;
		}
		text++;
	}

	return wynik/dzielnik;
}

SIGNAL( SIG_UART_RECV ){
	unsigned char znak;
	unsigned int newpos=pos++;
	
	znak=UDR;
	if(newpos>250 ){
		pos=0;
	}
	if(znak=='\n'){ pos=0;
			//-----
			//USART_Transmit(napis[0]);
			if(strcomp(napis,"$GPGGA",5)==0){
				progress=1;		//licznik komend
				progress2=0;	//licznik satelit
				//time = strgetint(napis,1);
				//czy ok? strgetint(napis,6);
				progress2=strgetint(napis,7);
			}
			if(strcomp(napis,"$GPGSA",6)==0){
				//low cost version ;) sscanf(napis,"$GPGSA,A,3,02,12,23,30,31,,,,,,,,0.6,0.4,0.4*0D",);
				fix_type = strgetint(napis,2);
			}
			if(strcomp(napis,"$GPGSV",6)==0){
				progress=strgetint(napis,3);
			}
			if(strcomp(napis,"$GPRMC",6)==0){
				gpsdata.time = strgetulint(napis,1);
				gpsdata.posx = strgetdouble(napis,3);
				if( *(strgetpos(napis,4)+1) == 'S' ) gpsdata.posx=-gpsdata.posx;
				gpsdata.posy = strgetdouble(napis,5);
				if( *(strgetpos(napis,6)+1) == 'W' ) gpsdata.posy=-gpsdata.posy;
				bargraf_line(BAR_GRN,progress,1);
				bargraf_line(BAR_RED,progress2,1);
			}
			
			napis[newpos]='\n';
			PORTC ^= _BV(5);
			//UCSRB = (1<<TXEN);
			//for(int i=0;i<=newpos;i++)
			//	USART_Transmit(napis[i]);
			
			//UCSRB = (1<<RXCIE)|(1<<RXEN)|(1<<TXEN);
			//----
			//}
	
	}
	napis[newpos]=znak;
	//USART_Transmit(znak);
}

int timer_clock=0;
SIGNAL (SIG_OVERFLOW1)
{
	if(fix_type>1 && timer_clock++>=12){
			timer_clock=0;
			eeprom_pos++;
			if(eeprom_pos>41)eeprom_pos=41;
			
			eeprom_write_block(&eeprom_pos, &eeprom_data,sizeof(eeprom_pos));
			eeprom_write_block(&gpsdata, (&eeprom_data)+sizeof(eeprom_pos)/2+(eeprom_pos-1)*sizeof(gpsdata)/2,sizeof(gpsdata));
			if(eeprom_pos>=41){
				bargraf_line(BAR_RED,10,1);
				bargraf_draw();
			}
	}
	TCNT1 = 11536;        // przeaduj timer 1
}

int main(void)
{

	//Zmienne
	int i;
	//int num=0;
	int pulse=0;

	//Dioda zasilania
    DDRC  |=  _BV(4);
	PORTC &=  ~_BV(4);

	//Dioda aktywnoci
    DDRC  |=  _BV(5);
	PORTC &=  ~_BV(5);
	
	//Przyciski
	DDRD  &= ~_BV(2) | ~_BV(3) | ~_BV(4);
	PORTD |=  _BV(2) |  _BV(3) |  _BV(4);
	//UP-2, CENTER-3, DOWN-4??
	
	//Speaker
	//DDRC |= _BV(1);
	//PORTC &= ~_BV(1);
	
	//EEPROM - pozycja
	
	eeprom_read_block(&eeprom_pos,&eeprom_data,sizeof(eeprom_pos));

	//Inicjalizacja
	bargraf_init();
	bargraf_line(BAR_GRN,progress,1);
	USART_Init();
	
	//Timer1
	TIMSK = _BV(TOIE1);				// wcz obsug przerwa T/C1
	TCNT1 = 11536;					// warto pocztkowa T/C1
	TCCR1A = 0x00;					// wcz tryb czasomierza T/C1
	TCCR1B = _BV(CS10)|_BV(CS12);	// preskaler ck/1024

	
	//Czyszczenie napisu
	for(i=0;i<254;i++) napis[i]=' ';
	
	sei();
	
/*	while(1){
		znak=USART_Receive();
		//PORTC ^= _BV(5);
		if(pos++>=255) pos=0;
		if(znak == '$' ){
		PORTC ^= _BV(4);
			//-----
			//UCSRB = (1<<TXEN);
			for(int i=0;i<=pos;i++)
				USART_Transmit(napis[i]);
			
			//UCSRB = (1<<RXEN)|(1<<TXEN);
			//----
			pos=0;
			USART_Flush();
		}
		napis[pos]=znak;
		//USART_Transmit(znak);
	}
*/

	while(1){
	    PORTC &= ~_BV(5);
		if(!(PIND & _BV(2)) ){
			czypokazywac = (czypokazywac==0?1:0);
			while(!(PIND & _BV(2)))
				bargraf_draw();
		}
		
		if(!(PIND & _BV(3)) ){
			//eeprom_write_byte(&eeprom_val, 12<<time);
			//eeprom_write_word(&eeprom_val, 8<<time);
			//eeprom_write_word(&eeprom_val, 4<<time);-
			eeprom_pos++;
			if(eeprom_pos>41)eeprom_pos=41;
			
			eeprom_write_block(&eeprom_pos, &eeprom_data,sizeof(eeprom_pos));
			eeprom_write_block(&gpsdata, (&eeprom_data)+sizeof(eeprom_pos)/2+(eeprom_pos-1)*sizeof(gpsdata)/2,sizeof(gpsdata));
			if(eeprom_pos>=41){
				bargraf_line(BAR_RED,10,1);
				bargraf_draw();
			}
			
			while(!(PIND & _BV(3)))
				bargraf_draw();
		}
		
		if(!(PIND & _BV(4)) && progress>0){
			eeprom_pos=0;
			while(!(PIND & _BV(4)))
				bargraf_draw();
		}
		pulse++;
		if(fix_type >= 3 && pulse == 35){ PORTC |=  _BV(4); }
		if(fix_type >= 3 && pulse == 40){ PORTC &= ~_BV(4); }
		if(fix_type >= 2 && pulse == 45){ PORTC |=  _BV(4); }
		if(fix_type >= 2 && pulse >= 50){ PORTC &= ~_BV(4); pulse=0; }
		else if(pulse >=50){ pulse=0; }
		//if(num++ >= 500){ num=0; PORTC^=_BV(5); }
		if(czypokazywac) bargraf_draw();
	}
	
}
